/*
このファイルの中身は、NTT オープンソースライセンス　バージョン 1.0（「本
契約」という）の適用を受けます。
本契約を遵守しない限り、このファイルを使用してはなりません。
本契約のコピーは、次のＵＲＬから入手できます。
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

本契約に基づき頒布されるソフトウェアは、現状のまま、明示又は黙示のあらゆ
る種類の保証なしで、頒布されます。本契約に基づく権利及び制限を律する特定
の文言については、本契約を参照してください。

「オリジナルコード」は、 NTT Cyber Space Laboratories Code です。 
「オリジナルコード」の「初期開発者」は、日本電信電話株式会社です。  
日本電信電話株式会社により創作された部分は、Copyright (C) 2004 
日本電信電話株式会社 です。
全ての権利が留保されます。 
「コントリビュータ」：_____________________________________ 


The contents of this file are subject to the NTT Opensource License
Version 1.0 (the License); you may not use this file except in
compliance with the License. You may obtain a copy of the License at
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

Software distributed under the License is distributed on an AS IS
basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
License for the specific language governing rights and limitations
under the License.

The Original Code is NTT Cyber Space Laboratories Code .

The Initial Developer of the Original Code is NIPPON TELEGRAPH AND 
TELEPHONE CORPORATION.
Portions created by the NIPPON TELEGRAPH AND TELEPHONE CORPORATION 
are Copyright (C) 2004 NIPPON TELEGRAPH AND TELEPHONE CORPORATION. 
All Rights Reserved.

Contributor(s) ______________________________________.
*/

//
//	Perception学習管理クラス
//			変更履歴
// 2004.01.08 新規作成 suzuki
//

package jp.co.ntt.lms.lo.Perception;

import java.sql.SQLException;
import java.util.Hashtable;

import jp.co.ntt.lms.lo.LOException;
import jp.co.ntt.lms.lo.LearnData;
import jp.co.ntt.lms.lo.LearnManagerType2;
import jp.co.ntt.lms.lo.LoConstant;
import jp.co.ntt.lms.lo.LoLogDataAccess;
import jp.co.ntt.lms.xmo.DataAccess;
import jp.co.ntt.lms.xmo.XMOException;
import jp.co.ntt.lms.xmo.Assignments.AssignmentsClient;
import jp.co.ntt.lms.xmo.People.PeopleClient;
import jp.co.ntt.lms.xmo.util.DebugLog;

import org.apache.commons.lang.StringEscapeUtils;

/**
 * 学習管理インタフェースクラス
 *
 * <PRE>
 *   Loの学習を管理する。
 *   LoServerクラスが所有する。
 *   下位に各Loの学習管理クラスを持つ。
 * </PRE>
 *
 */
public class PerceptionLearnManager extends LearnManagerType2
	implements PerceptionPropertyDef
{

	/**
	 * 学習開始処理
	 *
	 * @param Hashtabel パラメータリスト
	 * @return Object 学習開始URL
	 * @exception LOException LO固有の例外エラー
	 */
	protected Object startLearnAction(Hashtable htbParam, DataAccess objDataAccess)
		throws LOException
	{
		LearnData objRet = new LearnData();
		try
		{
			// Perception教材詳細情報を設定します
			setPerceptionLoData( htbParam );

			// ユーザIDとLOIDの取得
			// 学習回数を取得します
			String strUserID = (String)htbParam.get( USER );
			String strLoID = (String)htbParam.get( LOID );

			LoLogDataAccess objLoLogDataAccess = new LoLogDataAccess();

			int intStudyCount = objLoLogDataAccess.getStudyCount( strUserID, strLoID, objDataAccess );

			String strSessionID = "" + intStudyCount;
			// 学習回数を設定する
			htbParam.put( STUDYCOUNT, strSessionID );

			// 教材URLを取得します
			PerceptionLoURLMaker objURLMaker = new PerceptionLoURLMaker();
			String strLearnURL = objURLMaker.makeStartLearnURL(htbParam, objDataAccess);
			PerceptionLoEnv objEnv    = new PerceptionLoEnv();
			String strEstimation   = objEnv.getEstimation();
			objRet.setLearnURL(strLearnURL);
			objRet.setEstimation(strEstimation);


		}
		catch(SQLException se ) {
			DebugLog.write( this.getClass(), se, DebugLog.HIGHT );
			throw new LOException( se.getMessage() );
		}
		catch(LOException le)
		{
			throw le;
		}
		catch(Exception e)
		{
			DebugLog.write( this.getClass(), e, DebugLog.HIGHT );
			throw new LOException( e.getMessage() );
		}
		return objRet;
	}

	/**
	 * 学習終了処理
	 *
	 * @param Hashtabel パラメータリスト
	 * @return Object NULL
	 * @exception LOException Lo固有の例外エラー
	 */
	synchronized protected Object endLearnAction(Hashtable htbParam, DataAccess objDataAccess)
		throws LOException
	{
		Object objRet = null;

		try
		{
			DebugLog.write( getClass(), "endLearnAction(Hashtable[" + htbParam +"],DataAccess)",DebugLog.ROW);
			// Perception教材詳細情報を設定します
			setPerceptionLoDataLoId( htbParam );

			// AssessmentIDからLOIDを取得します。
			String strAssessmentID = (String)htbParam.get( TEST_ID );
			PerceptionLoDataAccess objPerceptionDataAccess = new PerceptionLoDataAccess();
			String strLoID = objPerceptionDataAccess.getLOIDFromAssessmenID(strAssessmentID);
			
			
			// 学習回数を取得します
			String strUserID = (String)htbParam.get( USER_ID );

			PeopleClient objPeople = new PeopleClient();
			objPeople.setWhereForeignID(strUserID); // このstrUserIDは外部ユーザID
			if( !objPeople.select() ) {
				// 検索がうまくいかなかった場合
				DebugLog.write(this.getClass(), "学習者内部ID検索失敗", DebugLog.HIGHT);
			}
			else{
				while(objPeople.next())
				{
					strUserID = objPeople.getUserID(); // 外部ID=>内部ID擦りかえ
				}
			}

			LoLogDataAccess objLoLogDataAccess = new LoLogDataAccess();
			int intStudyCount = objLoLogDataAccess.getStudyCount(strUserID, strLoID, objDataAccess);
			String strSessionID = intStudyCount + "";
			// キャッシュからログ操作クラスを取得します
			PerceptionLoLogControl objLogControl = new PerceptionLoLogControl( strUserID, strLoID, strSessionID );
			if(objLogControl != null){
				objLogControl.insertLog( htbParam, objDataAccess );
			} else {
				objLogControl = new PerceptionLoLogControl( strUserID, strLoID, strSessionID );
				objLogControl.insertLog( htbParam, objDataAccess );
			}


			// 学習回数のカウントアップ
			AssignmentsClient assignmentsClient = null;
			assignmentsClient = new AssignmentsClient();

			// 学習回数カウントアップ対象LOIDを取得
			String strTargetLOID = (String)htbParam.get( TARGETLOID );

			DebugLog.write( getClass()
				, "AssignmentsClient#countupStudyCount("
					+ "\"" + strUserID +"\""
					+ ", \""+ strTargetLOID +"\""
					+ ", \"" + LoConstant.LO_TYPE_PERCEPTION +"\")"
				, DebugLog.ROW );
			assignmentsClient.countupStudyCount(
					strUserID, strTargetLOID, LoConstant.LO_TYPE_PERCEPTION);			
			
			// ステータス伝播用に
			// 内部ユーザーID, LOID をセットする
			htbParam.put(USER, strUserID);
			//LOID は Real LOID でなければならない
			htbParam.put(LOID, strLoID);
		}
		catch(SQLException se ) {
			DebugLog.write( this.getClass(), se, DebugLog.HIGHT );
			throw new LOException( se.getMessage() );
		}
		catch(LOException le)
		{
			throw le;
		}
		catch(XMOException e ) {
			DebugLog.write( this.getClass(), e, DebugLog.HIGHT );
			throw new LOException( e.getMessage() );
		}
		catch(Exception e ) {
			DebugLog.write( this.getClass(), e, DebugLog.HIGHT );
			throw new LOException( e.getMessage() );
		}

		return objRet;
	}

	/**
	 * Perception教材詳細情報を設定します
	 */
	private void setPerceptionLoData( Hashtable htbParam )
		throws LOException
	{

		// Dataアクセスクラスを使用して、詳細情報を取得する
		PerceptionLoDataAccess objDataAccess = new PerceptionLoDataAccess();
		PerceptionLoData[] objData = objDataAccess.getData( htbParam );

		for( int i = 0; i < objData.length; i++ ) {
			// ハッシュに必要な項目を設定
			// 教材IDの設定
			htbParam.put( ASSESSMENTID, objData[i].getAssessmentID() );
		}
	}

	/**
	 * Perception教材詳細情報を設定します
	 */
	private void setPerceptionLoDataLoId( Hashtable htbParam )
		throws LOException
	{

		// Dataアクセスクラスを使用して、詳細情報を取得する
		PerceptionLoDataAccess objDataAccess = new PerceptionLoDataAccess();
		String strAssessmentID = (String)htbParam.get( ASSESSMENTID );
		htbParam.put( "condition_key", " WHERE assessment_id='" + StringEscapeUtils.escapeSql(strAssessmentID) + "'");
		PerceptionLoData[] objData = objDataAccess.getData( htbParam );

		for( int i = 0; i < objData.length; i++ ) {
			// ハッシュに必要な項目を設定
			// 教材IDの設定
			// LOIDを設定
			htbParam.put( LOID, objData[i].getLoID() );
		}
	}
}

